# -*- coding: utf-8 -*-
"""
Created on Mon Apr 24 15:08:54 2023

@author: sarah
"""

# -*- coding: utf-8 -*-
"""
Created on Fri Apr 21 15:13:43 2023

@author: sarah
"""



import os
import numpy as np
import pandas as pd
import tkinter as tk
import seaborn as sns
import openpyxl
import matplotlib.pyplot as plt
import re
from tkinter import filedialog


def NPV_summary(self):
    input_str = self.irange_entry.get()
    input_list = input_str.split(",")
    input_list = [int(num.strip()) for num in input_list]
    jrange = int(self.jrange_entry.get())
    # Create a new workbook to store the results
    result_workbook = openpyxl.Workbook()
    result_worksheet = result_workbook.active

    # Set the column header for the result worksheet
    result_worksheet['A1'] = 'Name'
    result_worksheet['B1'] = 'Value($M))'

    # Iterate through the input_list and process each Excel file
    for D in input_list:
        for M in range(1, jrange+1):
            
            dir_path =f"E:/OLYMPUS_{D}/OLYMPUS_{D}_{M}/OLYMPUS_{D}"
  
            if not os.path.exists(dir_path):
                 # RSM file doesn't exist, so pass and go to the next one
              continue
          
            # Construct the file path and load the Excel file
            npv_file_path = f"{dir_path}/NPV_Calc_{D}_{M}.xlsx"
            if not os.path.exists(npv_file_path):
                 # RSM file doesn't exist, so pass and go to the next one
              continue
            npv_workbook = openpyxl.load_workbook(npv_file_path)
            
            # collect the final NPV value
            # Get the active worksheet from the NPV workbook
            npv_worksheet = npv_workbook.active
            
            # Variable to store the last non-zero cell in the worksheet
            last_non_zero_cell = None
            
            # Iterate over rows in reverse order, starting from the last row
            for i in range(npv_worksheet.max_row, 0, -1):  
                # Get the cell at the last column of the current row
                cell = npv_worksheet.cell(row=i, column=npv_worksheet.max_column)
                # Get the value of the cell
                value = cell.value

                # Check if the value is non-zero
                if value != 0:
                    # Store the reference to the last non-zero cell
                    last_non_zero_cell = cell
                    # Exit the loop as we have found the last non-zero value
                    break
            # Check if a non-zero cell was found    
            if last_non_zero_cell is not None:
                    # Get the value from the last non-zero cell
                    value = last_non_zero_cell.value
  
            
            # Write the result to the result worksheet
            name = f"OLYMPUS_{D}_{M}"
            row = (name, value)
            result_worksheet.append(row)
            
    # Save the result workbook to a file
    result_workbook.save('E:/OLYMPUS_NPV.xlsx')
    
    # Write the DataFrame to the same Excel file
    input_file_path = 'E:/OLYMPUS_NPV.xlsx'
    df = pd.read_excel(input_file_path)
    df.to_excel('E:/OLYMPUS_NPV.xlsx', index=False, header=True)

    # Group the DataFrame by the second component of the 'name' column
    groups = df.groupby(df['Name'].str.split('_', expand=True)[1])

    # Write each group to a separate sheet in a new Excel file
    output_file_name = 'E://NPV_separated.xlsx'
    with pd.ExcelWriter(output_file_name) as writer:
        for name, group in groups:
            
            # Create a sheet name for the current group
            sheet_name = f'OLYMPUS_{name}'
            
            # Write the current group to a new sheet in the Excel file
            group.to_excel(writer, sheet_name=sheet_name, index=False)


        
class MyGUI:
    def __init__(self):
        self.root = tk.Tk()
        self.frame1 = self.create_frame1()
        self.frame4 = self.create_frame4()
        self.frame5 = self.create_frame5()
        #self.add_logo ()
        self.root.geometry("900x700")
        self.root.title("NPV Calculations")  # Set the window title
        #self.root.iconbitmap("C:/Users/sarah/OneDrive/Desktop/Thesis/NTNU_logo_400x400.ico")  # Set the window icon
        
        self.excel_file = None
        self.sheet_name = None
        self.sheet_data = None
       

    def create_frame1(self):
        frame1 = tk.Frame(self.root)
        frame1.pack()
       
        # First column
        col1 = tk.Frame(frame1)
        col1.pack(side=tk.LEFT, padx=10, pady=5)
       
        self.title1_label = tk.Label(col1, text="General Setup", font = ('Calibri', 12, 'bold'),fg='#149998')
        self.title1_label.pack(anchor=tk.CENTER, padx=5, pady=5,)
        
        # Label and entry for irange
        self.irange_label = tk.Label(col1, text="Enter a comma-separated list of realizations:")
        self.irange_label.pack(anchor=tk.W, padx=5, pady=5,)
        self.irange_entry = tk.Entry(col1)
        self.irange_entry.insert(tk.END, "40,50") 
        self.irange_entry.pack(anchor=tk.W, padx=5, pady=5,)
        
        # Label and entry for jrange
        self.jrange_label = tk.Label(col1, text='Enter the number of BHP samples:')
        self.jrange_label.pack(anchor=tk.W, padx=10, pady=5, )
        self.jrange_entry = tk.Entry(col1)
        self.jrange_entry.insert(tk.END, "1") 
        self.jrange_entry.pack(anchor=tk.W, padx=10, pady=5, )
        
        # Label and entry for pre production years
        self.well_label = tk.Label(col1, text='Enter the number years before starting the production:')
        self.well_label.pack(anchor=tk.W, padx=10, pady=5,)
        self.well_entry = tk.Entry(col1)
        self.well_entry.insert(tk.END, "5") 
        self.well_entry.pack(anchor=tk.W, padx=10, pady=5, )
        
        # Label and entry for production years
        self.pro_label = tk.Label(col1, text='Enter the number of production years:')
        self.pro_label.pack(anchor=tk.W, padx=10, pady=5, )
        self.pro_entry = tk.Entry(col1)
        self.pro_entry.insert(tk.END, "25") 
        self.pro_entry.pack(anchor=tk.W, padx=10, pady=5,)
        
        
        # Second column
        col2 = tk.Frame(frame1)
        col2.pack(side=tk.LEFT, padx=10, pady=5)
        
        self.title2_label = tk.Label(col2, text="NPV values", font = ('Calibri', 12, 'bold'),fg='#149998')
        self.title2_label.pack( anchor=tk.W, padx=10, pady=5,)

        # Label and entry for drilling cost
        self.drillcost_label = tk.Label(col2, text='Drilling cost($M)')
        self.drillcost_label.pack(anchor=tk.W, padx=10, pady=5)
        self.drillcost_entry = tk.Entry(col2)
        self.drillcost_entry.insert(tk.END, '100') 
        self.drillcost_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        # Label and entry for piping cost
        self.pipcost_label = tk.Label(col2, text='Piping cost($M)')
        self.pipcost_label.pack(anchor=tk.W, padx=10, pady=5)
        self.pipcost_entry = tk.Entry(col2)
        self.pipcost_entry.insert(tk.END, "500") 
        self.pipcost_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        # Label and entry for piping years
        self.pipt_label = tk.Label(col2, text='Piping years')
        self.pipt_label.pack(anchor=tk.W, padx=10, pady=5)
        self.pipt_entry = tk.Entry(col2)
        self.pipt_entry.insert(tk.END, "3") 
        self.pipt_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        # Label and entry for manifold cost
        self.mfcost_label = tk.Label(col2, text='Manifold cost($M)')
        self.mfcost_label.pack(anchor=tk.W, padx=10, pady=5)
        self.mfcost_entry = tk.Entry(col2)
        self.mfcost_entry.insert(tk.END, "200") 
        self.mfcost_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        # Label and entry for number of manifolds
        self.mfnum_label = tk.Label(col2, text='Number of manifolds')
        self.mfnum_label.pack(anchor=tk.W, padx=10, pady=5)
        self.mfnum_entry = tk.Entry(col2)
        self.mfnum_entry.insert(tk.END, "3") 
        self.mfnum_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        # Label and entry for fixed OPEX cost
        self.OPEX_label = tk.Label(col2, text='Enter the OPEX')
        self.OPEX_label.pack(anchor=tk.W, padx=10, pady=5)
        self.OPEX_entry = tk.Entry(col2)
        self.OPEX_entry.insert(tk.END, "100") 
        self.OPEX_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        col3 = tk.Frame(frame1)
        col3.pack(side=tk.LEFT, padx=10, pady=5)
        
        # Label and entry for oil price
        self.oil_label = tk.Label(col3, text='Oil price($/Sm3)')
        self.oil_label.pack(anchor=tk.W, padx=10, pady=5)
        self.oil_entry = tk.Entry(col3)
        self.oil_entry.insert(tk.END, "760") 
        self.oil_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        # Label and entry for gas price
        self.gas_label = tk.Label(col3, text='gas price($/Sm3)')
        self.gas_label.pack(anchor=tk.W, padx=10, pady=5)
        self.gas_entry = tk.Entry(col3)
        self.gas_entry.insert(tk.END, "76") 
        self.gas_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        # Label and entry for water expenses
        self.wcost_label = tk.Label(col3, text='Water cost($/Sm3)')
        self.wcost_label.pack(anchor=tk.W, padx=10, pady=5)
        self.wcost_entry = tk.Entry(col3)
        self.wcost_entry.insert(tk.END, "50") 
        self.wcost_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        # Label and entry for interest rate
        self.interest_label = tk.Label(col3, text='interest rate(%)')
        self.interest_label.pack(anchor=tk.W, padx=10, pady=5)
        self.interest_entry = tk.Entry(col3)
        self.interest_entry.insert(tk.END, "5") 
        self.interest_entry.pack(anchor=tk.W, padx=10, pady=5)
        
        
        return frame1
   
    
   
    # Frame for NPV button
    def create_frame4(self):
        frame4 = tk.Frame(self.root)
        frame4.pack()
        self.NPV_button = tk.Button(frame4, text="NPV ", command=self.run_function4,font=('Calibri', 12, 'bold'))
        self.NPV_button.pack(pady=10)
        return frame4
    
   
    # Frame for result visualization
    def create_frame5(self):
        frame5 = tk.Frame(self.root)
        self.title1_label = tk.Label(text="Result Visualization", font = ('Calibri', 12, 'bold'),fg='#149998')
        self.title1_label.pack( padx=5, pady=5,)
        frame5.pack()

        self.selected_file = tk.StringVar()
        self.selected_file_label = tk.Label(frame5, textvariable=self.selected_file)
        self.selected_file_label.grid(row=0, column=2 ,padx=10, pady=10)

        self.selected_sheet = tk.StringVar()
        self.selected_sheet_label = tk.Label(frame5, textvariable=self.selected_sheet)
        self.selected_sheet_label.grid(row=1, column=2, padx=10, pady=10,)

        # create widgets
        self.file_label = tk.Label(frame5, text="Excel file:")
        self.file_button = tk.Button(frame5, text="Select file", command=self.select_file)
        self.sheet_label = tk.Label(frame5, text="Sheet:")
        self.sheet_var = tk.StringVar()
        self.sheet_dropdown = tk.OptionMenu(frame5, self.sheet_var, [])
        self.sheet_dropdown.configure(state="disabled")
        self.seperated_NPV_button = tk.Button(frame5, text="Seperated NPV Plot", command=self.NPV_sep)
        self.seperated_RF_button = tk.Button(frame5, text="Seperated RF Plot", command=self.RF_sep)
        self.total_NPV_button = tk.Button(frame5, text="Total NPV Plot", command=self.NPV_tot)
        self.total_RF_button = tk.Button(frame5, text="Total RF Plot", command=self.RF_tot)

        # layout widgets
        self.file_label.grid(row=0, column=0, padx=10, pady=10)
        self.file_button.grid(row=0, column=1, padx=10, pady=10)
        self.sheet_label.grid(row=1, column=0, padx=10, pady=10)
        self.sheet_dropdown.grid(row=1, column=1, padx=5, pady=5)
        self.seperated_NPV_button.grid(row=20, column=1, padx=20, pady=20)
        self.seperated_RF_button.grid(row=20, column=2, padx=20, pady=20)
        self.total_NPV_button.grid(row=20, column=3, padx=20, pady=20)
        self.total_RF_button.grid(row=20, column=4, padx=20, pady=20)

       
        return frame5

    def select_file(self):
        self.excel_file = filedialog.askopenfilename(filetypes=[("Excel files", "*.xlsx")])
        if self.excel_file:
            self.update_sheet_dropdown()
            self.sheet_dropdown.configure(state="normal")

            # Add the following lines to update the selected file label
            self.selected_file.set("Selected file: " + self.excel_file)

    def update_sheet_dropdown(self):
        workbook = openpyxl.load_workbook(filename=self.excel_file)
        sheets = workbook.sheetnames
        self.sheet_dropdown["menu"].delete(0, "end")
        for sheet in sheets:
            self.sheet_dropdown["menu"].add_command(label=sheet, command=lambda s=sheet: self.select_sheet(s))

    def select_sheet(self, sheet_name):
        self.sheet_name = sheet_name
        self.selected_sheet.set("Selected sheet: " + sheet_name)

    def NPV_sep(self):
        if self.sheet_name and self.excel_file:
            workbook = openpyxl.load_workbook(filename=self.excel_file)
            sheet = workbook[self.sheet_name]
            data = []
            for row in sheet.iter_rows(min_row=2, values_only=True):
                data.append(row)
                # Create the first plot (KDE plot)
            df = pd.DataFrame(data, columns=["name", "Value($M)"])

            # Create the first plot (KDE plot)
            kde_plot = sns.displot(data=df, x="Value($M)", kind="kde", height=6, aspect=1.4,warn_singular=False)


            # Create the second plot (ECDF plot)
            ecdf_plot = sns.displot(data=df, x='Value($M)', kind="ecdf", height=6, aspect=1.4)

            # Create the directory to save the plots in, if it doesn't already exist
            if not os.path.exists("my_plots"):
                os.makedirs("my_plots")

            # Save the plots in the 'my_plots' directory
            kde_plot.savefig(f'E:/my_plots/{self.sheet_name}_NPV_sep_kde_plot.png')
            ecdf_plot.savefig(f"E:/my_plots/{self.sheet_name}_NPV_sep_ecdf_plot.png")
            
    def RF_sep(self):
          if self.sheet_name and self.excel_file:
              workbook = openpyxl.load_workbook(filename=self.excel_file)
              sheet = workbook[self.sheet_name]
              data = []
              for row in sheet.iter_rows(min_row=2, values_only=True):
                  data.append(row)
                  # Create the first plot (KDE plot)
              df = pd.DataFrame(data, columns=["Recovery factor", "name"])

              # Create the first plot (KDE plot)
              kde_plot = sns.displot(data=df, x="Recovery factor", kind="kde", height=6, aspect=1.4,common_norm=False)


              # Create the second plot (ECDF plot)
              ecdf_plot = sns.displot(data=df, x="Recovery factor", kind="ecdf", height=6, aspect=1.4,common_norm=False)

              # Create the directory to save the plots in, if it doesn't already exist
              if not os.path.exists("my_plots"):
                  os.makedirs("my_plots")

              # Save the plots in the 'my_plots' directory
              kde_plot.savefig(f'E:/my_plots/{self.sheet_name}RF_sep_kde_plot.png')
              ecdf_plot.savefig(f"E:/my_plots/{self.sheet_name}RF_sep_ecdf_plot.png")  
              
              
    def NPV_tot(self):
        if self.sheet_name and self.excel_file:
            workbook = openpyxl.load_workbook(filename=self.excel_file)
            sheet = workbook[self.sheet_name]
            data = []
            for row in sheet.iter_rows(min_row=2, values_only=True):
                data.append(row)

            # Create filtered dataframe
            filtered_df = pd.DataFrame(data, columns=['Name', 'Value($M)'])
            filtered_df['OLYMPUS_I'] = filtered_df['Name'].str.extract(r'(OLYMPUS_\d+)')

           # Create the KDE plot
            kde_plot = sns.displot(data=filtered_df, x="Value($M)", hue="OLYMPUS_I", kind="kde", height=6, aspect=1.4,common_norm=False )
            kde_plot.set(yscale='linear')
            kde_plot.savefig('E:/my_plots/NPV_OLYMPUS_sets_pdf.png')
            cdf_plot = sns.displot(data=filtered_df, x="Value($M)", hue="OLYMPUS_I", kind="ecdf", height=6, aspect=1.4)
            cdf_plot.set(yscale='linear')
            cdf_plot.savefig('E:/my_plots/NPV_OLYMPUS_sets_cdf.png')
         

              
    def RF_tot(self):
            if self.sheet_name and self.excel_file:
                workbook = openpyxl.load_workbook(filename=self.excel_file)
                sheet = workbook[self.sheet_name]
                data = []
                for row in sheet.iter_rows(min_row=2, values_only=True):
                    data.append(row)
                    # Create the first plot (KDE plot)
                df = pd.DataFrame(data, columns=["Recovery factor", "name"])
                df['OLYMPUS_I'] = df['name'].str.extract(r'(OLYMPUS_\d+)')

               # Create the KDE plot
                kde_plot = sns.displot(data=df, x="Recovery factor", hue="OLYMPUS_I", kind="kde", height=6, aspect=1.4)
                kde_plot.savefig('E:/my_plots/RF_OLYMPUS_sets_pdf.png')
                
                cdf_plot = sns.displot(data=df, x="Recovery factor", hue="OLYMPUS_I", kind="ecdf", height=6, aspect=1.4)
                cdf_plot.savefig('E:/my_plots/RF_OLYMPUS_sets_cdf.png')
                #g = sns.FacetGrid(df, col='OLYMPUS_set', col_wrap=3, height=4)

                # Plot the PDF and ECDF for each OLYMPUS set in the FacetGrid
                #g.map(sns.histplot, 'Recovery factor', kde=False, stat='density', alpha=0.5, color='b',common_norm=False)
                #g.map(sns.ecdfplot, 'Recovery factor', alpha=0.5, color='r',common_norm=False)

                # Set titles for each plot
                #for ax in g.axes.flat:
                 #   ax.set_title(ax.get_title().replace("OLYMPUS_set = ", "OLYMPUS Set "))

                 # Save the plot
                #plt.savefig('E:/my_plots/RF_OLYMPUS_sets_pdf_ecdf.png')
                #plt.show()

          
       
     
    def browse_directory(self):
        directory_path = filedialog.askdirectory() +'/'
        print("Selected directory:", directory_path)
        self.directory_path_var.set(directory_path)
        
    
    
        
                      
    def run_function4(self): 
        
            
        input_str = self.irange_entry.get()
        input_list = input_str.split(",")
        input_list = [int(num.strip()) for num in input_list]
        jrange = int(self.jrange_entry.get())
        for l in input_list:
            for s in range(1, jrange+1):
                dir_path =f'E:/OLYMPUS_{l}/OLYMPUS_{l}_{s}/OLYMPUS/OLYMPUS_SCH.INC'
      
                if not os.path.exists(dir_path):
                     # RSM file doesn't exist, so pass and go to the next one
                  continue 
                with open(dir_path, 'r') as f:
                    text = f.read()
                    # matches "Prod_" followed by one or more digits
                    pattern = r"PROD-(\d+)"  

                # find all matches of the pattern in the text( to extract number of production wells)
                matches = re.findall(pattern, text)

                if matches:
                    last_match = matches[-1]  # select the last match
                    PROD_wells = int(last_match)  # convert the string to an integer
       
                else:
                    print("No production well  found")
             
                with open(dir_path, 'r') as f:
                    text = f.read()
                    pattern = r"INJ-(\d+)"  # matches "Prod_" followed by one or more digits
                    
                    # find all matches of the pattern in the text
                    matches = re.findall(pattern, text)

                if matches:
                    # select the last match
                    last_match = matches[-1]  
                    # convert the string to an integer
                    INJ_wells = int(last_match)  
       
                
                file_name = f"E:/OLYMPUS_{l}/OLYMPUS_{l}_{s}/OLYMPUS_{l}/production_profiles_{l}_{s}.xlsx"
                if not os.path.exists(file_name):
                    # RSM file doesn't exist, so pass and go to the next one
                    print('file doesnt exist')
                    continue
               

                # set the columns to extract
                #sheet1_columns = "yearly oil production(Sm3)"
                #sheet2_columns = "yearly water production(Sm3)"
                #sheet3_columns = "yearly gas production(Sm3)"

                # Read the Excel file into a dictionary of DataFrames
                df_oil = pd.read_excel(file_name, sheet_name=["Oil"])
                df_gas = pd.read_excel( file_name, sheet_name=['Gas'])
                df_water = pd.read_excel( file_name, sheet_name=[ "Water"])


                end_idx = int(self.pro_entry.get())
               
                
                df_oil_dict = pd.read_excel(file_name, sheet_name=["Oil"])
                df_oil = df_oil_dict["Oil"]
                end_idx = int(self.pro_entry.get()) 
                oil_data = df_oil.iloc[:end_idx, 2].tolist()
               
                
                df_gas_dict = pd.read_excel(file_name, sheet_name=["Gas"])
                df_gas = df_gas_dict["Gas"]
                end_idx = int(self.pro_entry.get()) 
                gas_data = df_gas.iloc[:end_idx, 2].tolist()
                
                
                df_water_dict = pd.read_excel( file_name, sheet_name=["Water"])
                df_water = df_water_dict["Water"]
                end_idx = int(self.pro_entry.get()) 
                water_data = df_water.iloc[:end_idx, 2].tolist()
                
               
                prod_years = len(oil_data)
                  
                  
                
                Row = prod_years + int( self.well_entry.get())
                Column = int(16)

                 
                # Initialize the NPV calculation matrix
                matrix = np.zeros([Row,Column])
                N_wells = INJ_wells + PROD_wells
               
                #Number of production wells and injection wells, respectively
                temp=N_wells
                Drilling_cost = int(self.drillcost_entry.get())
                Piping_cost = int(self.pipcost_entry.get()) 
                piping_years = int(self.pipt_entry.get())
                N_manifolds = int(self.mfnum_entry.get())
                Manifold_cost = int(self.mfcost_entry.get())
                oil_price = int(self.oil_entry.get())
                gas_price = int(self.gas_entry.get())
                water_cost = int(self.wcost_entry.get())
                OPEX = int(self.OPEX_entry.get())
                r = float(self.interest_entry.get())/100
            

                # Add column names
                column_names = ['Year','Number of wells', 'DRILLEX($M)','PipingEX($M)', 'ManifoldEx($M)', 'OPEX($M)', 'OilProd(SM3)', 'WaterProd(SM3)','GasProd(SM3)', 'OilRev($M)','GasRev($M)', 'WaterEx($M)', 'CAPEX($M)','Cashflow($M)','Discounted CF($M)','Cumulative CF($M)']
                matrix_df = pd.DataFrame(matrix, columns=column_names)

                for i in range (1,Row+1): #Write years in the matrix
                   matrix[i-1][0]=i
                   for j in range (1,5):
                       if temp != 0:
                           matrix[i-1][1]=j
                           temp-=1
              
                   matrix[i-1][2] = Drilling_cost*matrix[i-1][1]  # calculate DRILLEX
                   for k in range (piping_years): #Piping ependiture in 2 years
                       matrix[k][3] = Piping_cost 

                   matrix[0][4] = N_manifolds * Manifold_cost

                   sum = matrix[i-1][2] + matrix[i-1][3] + matrix[i-1][4] #Calculate CAPEX
                   matrix[i-1][12] = sum
                   sum = 0
                  
                   
                   
                  # oil_data_flat = list(itertools.chain.from_iterable(oil_data)) 
                   for L in range (int(self.well_entry.get())-1 ,Row):
                      # print(oil_data)
                 
                       matrix[L][6] = oil_data[L-int(self.well_entry.get())] #Import production profile , production starts at year 5
                       #print(oil_data)
                       matrix[L][7] = water_data[L-int(self.well_entry.get())]
                       matrix[L][8] = gas_data[L-int(self.well_entry.get())]
                       matrix[L][5] = OPEX 
                       
                    
                   matrix[i-1][9] = matrix[i-1][6] * oil_price /(1000000)
                   matrix[i-1][10] = matrix[i-1][8]*gas_price / 1000000            
                   matrix[i-1][11] = matrix[i-1][7]*water_cost / 1000000
                   matrix[i-1][13] = matrix[i-1][9] +matrix[i-1][10]  - matrix[i-1][11] - matrix[i-1][5] - matrix[i-1][12] #Calculate the cash flow
                   matrix[i-1][14] = matrix[i-1][13] / (1+r)**i #Calculate discounted cash flow

                   matrix[0][15]= matrix[0][14] #Calculate cumulative discounted cash flow 
                   negative_cash_flow = False  # Flag variable to track negative cash flow

              
                   if negative_cash_flow:
                       # Exclude the row with negative cash flow from calculations
                       matrix[i + 1][15] = 0  # Set the cumulated cash flow of the row to 0 or handle it as desired
                   for i in range(Row - 1):
                       if negative_cash_flow:
                           matrix[i + 1][15] = 0  # Replace all numbers with zero
                           continue
    
                       matrix[i + 1][15] = matrix[i][15] + matrix[i + 1][14]
                       prepro = int(self.well_entry.get())
    
                       if i >= prepro and matrix[i + 1][13] < 0:
                           print("Negative cash flow encountered. Stopping the process.")
                           negative_cash_flow = True
                  
              


              
                matrix_df.to_excel(f'E:/OLYMPUS_{l}/OLYMPUS_{l}_{s}/OLYMPUS_{l}/NPV_Calc_{l}_{s}.xlsx')
                NPV_summary(self)
            
              

          

    def run(self):
            self.frame1.pack()
            #self.frame2.pack()
            #self.frame3.pack()
            self.frame4.pack()
            self.frame5.pack()
            #self.frame.pack()
            
            # Pack the logo Label widget to make it visible
            #self.logo_label.pack()  
            self.root.mainloop()

if __name__ == '__main__':
    gui = MyGUI()
    gui.run()