# -*- coding: utf-8 -*-
'''
Created on Fri Apr 21 15:13:43 2023

@author: sarah
'''





import shutil
import random
import os
import numpy as np
from multiprocessing import Pool
import subprocess
from time import perf_counter
import pandas as pd
from tkinter import ttk
import tkinter as tk



def run1(address):
    '''Function to run a datafile in Eclipse'''
    subprocess.run(['eclrun', 'eclipse', address])
    


        
class MyGUI:
    def __init__(self):
        self.root = tk.Tk()
        self.frame1 = self.create_frame1()
        self.frame2 = self.create_frame2()
        self.frame3 = self.create_frame3()
        self.status_label = tk.Label(self.root, text='')
        #self.frame4 = self.create_frame4()
        #self.frame5 = self.create_frame5()
        #self.add_logo ()
        self.root.geometry('500x700')
        self.root.title('Realization setup')  # Set the window title
        #self.root.iconbitmap('C:/Users/sarah/OneDrive/Desktop/Thesis/NTNU_logo_400x400.ico')  # Set the window icon
        
        self.excel_file = None
        self.sheet_name = None
        self.sheet_data = None
       
       

     
        

         
       
       

    def create_frame1(self):
        frame1 = tk.Frame(self.root)
        
        #Frame title
        self.title1_label = tk.Label(text='Modifying realizations', font = ('Calibri', 12, 'bold'),fg='#149998')
        self.title1_label.pack(anchor=tk.CENTER, padx=5, pady=5,)
       
        
        # Label and entry for realizations
        self.irange_label = tk.Label(self.root, text='Enter a comma-separated list of realizations:')
        self.irange_label.pack()
        self.irange_entry = tk.Entry(self.root)
        self.irange_entry.pack()
        
        # Label and entry for BHP samples
        self.jrange_label = tk.Label(self.root, text='Enter the number of BHP samples:')
        self.jrange_label.pack()
        self.jrange_entry = tk.Entry(self.root)
        self.jrange_entry.pack()
        
        # Label and entry for the Lowest limit for BHP
        self.LL_label = tk.Label(self.root, text='Enter the lowest limit for BHP:')
        self.LL_label.pack()
        self.LL_entry = tk.Entry(self.root)
        self.LL_entry.pack()
       
        # Label and entry for the highest limit for BHP
        self.HL_label = tk.Label(self.root, text='Enter the highest limit for BHP:')
        self.HL_label.pack()
        self.HL_entry = tk.Entry(self.root)
        self.HL_entry.pack()
        
        #Creat the realizations
        self.submit_button = tk.Button(self.root, text='Create realizations', command=self.run_function1,font=('Calibri', 12, 'bold'))
        self.submit_button.pack(padx=10, pady=10)
   
        return frame1
    
    
    
    def create_frame2(self):
        frame2 = tk.Frame(self.root)
        #Frame title
        self.title1_label = tk.Label(text='Running Process', font = ('Calibri', 12, 'bold'),fg='#149998')
        self.title1_label.pack( padx=5, pady=5,)
        frame2.pack()
        
        # Label and entry for maximum number of processes
        self.max_processes_label = tk.Label(frame2, text='Maximum number of processes:')
        self.max_processes_label.pack(pady=10)
        self.max_processes_entry = tk.Entry(frame2) # fixed variable name
        self.max_processes_entry.pack(pady=10) # fixed variable name
        
        #button to run simulations in parallel 
        self.submit_button = tk.Button(frame2, text='Run', command=self.run_function2,font=('Calibri', 12, 'bold'))
        self.submit_button.pack( padx=5, pady=5)
        
        return frame2
    
    def create_frame3(self):
        frame3 = tk.Frame(self.root)
        #Frame title
        self.title_label = tk.Label(text='Gathering & Reading Output', font=('Calibri', 12, 'bold'),fg='#149998')
        self.title_label.pack(padx=5, pady=5)
        frame3.pack()
        
        #button to change RSM files to text files
        self.rename_button = tk.Button(frame3, text='Change RSM files format', command=self.rename_file,font=('Calibri', 12, 'bold'))
        self.rename_button.pack(pady=10)
        
        #button to save production profiles
        self.submit_button = tk.Button(frame3, text='Save production profiles', command=self.run_function3,font=('Calibri', 12, 'bold'))
        self.submit_button.pack(pady=10)
       
        return frame3
    
    

    #Function to change RSM extension to text 
    def rename_file(self):
        # Get the input values from the entry fields
        input_str = self.irange_entry.get()
        input_list = input_str.split(',')
        input_list = [int(num.strip()) for num in input_list]
        jrange = int(self.jrange_entry.get())
       
        # Iterate over the input values 
        for i in input_list :
            for j in range(1, jrange+1):
                my_file = f'E:/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS_{i}/OLYMPUS_{i}.RSM'
                # Check if the file exists
                if not os.path.exists(my_file):
                    # RSM file doesn't exist, so pass and go to the next one
                    continue
                # Rename the file by changing the extension to '.txt'
                base = os.path.splitext(my_file)[0]
                os.rename(my_file, base +'_RSM'+ '.txt')
     
    
    
       
    # Function to copy files from  the source address and making new sets of samples and realiaztions based on user input      
    def run_function1(self):
        # Get the input values from the entry fields
        input_str = self.irange_entry.get()
        input_list = input_str.split(',')
        input_list = [int(num.strip()) for num in input_list]
        jrange = int(self.jrange_entry.get())
        LL = self.LL_entry.get()
        HL = self.HL_entry.get()
    
        
        # Iterate over the input values
        for i in input_list:
            for j in range(1, jrange+1):
                # Define the directory paths
                directory_path = f'C:/Test2/OLYMPUS_{i}/OLYMPUS_{i}_{j}'
                os.makedirs(directory_path, exist_ok=True)
                
                # Copy source directories to destination directories
                src = f'C:/Users/sarah/OneDrive/Desktop/Test 3/OLYMPUS_{i}/OLYMPUS_{i}'
                dest = f'C:/Test2/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS_{i}'
                shutil.copytree(src, dest)
                
                src = r'C:/Users/sarah/OneDrive/Desktop/Test 3/OLYMPUS'
                dest = f'C:/Test2/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS'
                shutil.copytree(src, dest)
        
        
        

        Row = 11
        Column = 3
        matrix = np.zeros([Row,Column])
        #Write production years and BHP limitations in a matrix
        for i in range (0, Row): 
          matrix[i][0]=i+1
          matrix[i][1]=LL
          matrix[i][2]=HL
        
        
        # Function to open the schadule file and modify BHP pressure for production wells based on user input
        def replace_line(file_name, line_num, text): 
            # Read all lines from the file
            lines = open(file_name, 'r').readlines()
            # Replace the line at the specified line number with the given text
            lines[line_num] = text
            # Open the file in write mode
            out = open(file_name, 'w')
            # Write the modified lines back to the file
            out.writelines(lines)
            # Close the file
            out.close()
        
        # Iterate over the input values
        for i in input_list:
          for j in range (1,jrange+1):
            
           for k in range (0, 11) :
            # Open the file for reading   
            with open(f'C:/Test2/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS/OLYMPUS_SCH.INC', 'r') as my_file: 
               
               #read all lines in a list
               keyword = 'WCONPROD'            
               lines = my_file.readlines()
               # Iterate over the lines in the file
               for line in lines:
                 # Check if the keyword is present in the line
                 if line.find(keyword) != -1:
                   kw_line=lines.index(line)
                   well_line=int(matrix[k][0]+kw_line)
                   with open(f'C:/Test2/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS/OLYMPUS_SCH.INC') as f:
                     particular_line = f.readlines()[well_line]
                     #Convert string to array
                     x = particular_line.split() 
                     # Generate a new random BHP value within the specified limits
                     bhp=int(random.uniform(matrix[k][1],matrix[k][2]))
                     #New BHP value as string
                     x[4]='%s'%bhp  
                     #convert array to string
                     x1=' '.join(x) 
                     x =f'  {x1}\n' 
                     # Call the replace_line function to replace the line in the file
                     replace_line( f'C:/Test2/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS/OLYMPUS_SCH.INC', well_line, x)

    # Progress window shows  the loading bar for simulations parallel run  
    def open_progress_window(self):
     self.progress_window = tk.Toplevel(self.root)
     self.progress_window.title('Progress')
     self.progress_window.geometry('500x80')

     self.status_label = tk.Label(self.progress_window, text='Launching Eclipse in Parallel')
     self.status_label.pack()
    
     self.status_label2 = tk.Label(self.progress_window, text='Wait for the bar to be filled, then close the progress window and continue.')
     self.status_label2.pack()

     self.progress_bar = ttk.Progressbar(self.progress_window, length=200, mode='determinate')
     self.progress_bar.pack()

     return self.progress_window
     
    # Function to update the loading bar
    def update_progress(self, value):
     self.progress_bar['value'] = value
     self.progress_window.update()

    # Function for parallel run in Eclipse
    def run_function2(self):
     # Get the maximum number of processes from the entry field
     MAX_PROCESSES = int(self.max_processes_entry.get())
     
     # Get the initial time
     t0 = perf_counter()
    
     # Open the progress window and bring it to front
     self.progress_window = self.open_progress_window()
     self.progress_window.lift()  

     # Get the input values from the entry fields
     input_str = self.irange_entry.get()
     input_list = input_str.split(',')
     input_list = [int(num.strip()) for num in input_list]
     jrange = int(self.jrange_entry.get())

    # Generate the parallel run input based on the input values
     parallel_run_input = [
        os.path.join(f'C:/Test2/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS_{i}/OLYMPUS_{i}.DATA')
        for i in input_list
        for j in range(1, jrange + 1)
    ]

     # Set the initial value and maximum value of the progress bar
     self.progress_bar['value'] = 0
     self.progress_bar['maximum'] = len(parallel_run_input)
    
     # Update the progress window before starting the calculations
     self.progress_window.update()  
     # Start the parallel execution using a pool of processes
     with Pool(processes=min(len(parallel_run_input), MAX_PROCESSES)) as pool:
        results = []
        for i, _ in enumerate(pool.imap_unordered(run1, parallel_run_input)):
            results.append(_)
            self.update_progress(i + 1)
     # Update the status label to indicate the completion time
     self.status_label.config(text=f'Finished in {perf_counter() - t0:.2f} seconds')
     
     
     # Update the progress window after the calculation
     self.progress_window.update()



    def run_function3(self):
           # Get input values from the entry fields
           input_str = self.irange_entry.get()
           input_list = input_str.split(',')
           input_list = [int(num.strip()) for num in input_list]
           jrange = int(self.jrange_entry.get())
           
           for i in input_list :
               for j in range(1, jrange+1):
                   # Define the path to the RSM file
                   rsm_file = f'E:/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS_{i}/OLYMPUS_{i}_RSM.txt'
        
                   if not os.path.exists(rsm_file):
                       # RSM file doesn't exist, so pass and go to the next one
                    continue
                   
    
                   
                   # Initialize production profile arrays
                   production_profile = np.zeros(20)
                   
                   with open(rsm_file, 'r') as f:
                       lines = f.readlines()
                       
                       for d in range(0, 20):
                           # Extract cumulative oil production data
                           keyword = 'FOPT'
                           kw_line = next((index for (index, line) in enumerate(lines) if keyword in line), None)
                           print(f'kw_line: {kw_line}')
                           wanted_line = 2 + int(0) + kw_line
                           particular_line = lines[wanted_line]
                           x = particular_line.split()
                           search_string = '*10**3'

                           if any(search_string in element for element in x):
                               wanted_line1 = 7 + d + kw_line
                               particular_line = lines[wanted_line1]
                               x1 = particular_line.split()   
                               production_profile[d] = float(x1[8]) * 10**3
                               #
                           else:
                              wanted_line1 = 6 + d + kw_line
                              particular_line = lines[wanted_line1]
                              x1 = particular_line.split()   
                              production_profile[d] = float(x1[8])
                              
                          
                   
                   # Create a DataFrame to store the production profile data
                   df_oil = pd.DataFrame(data={'Year': range(1, 21), 'cumulative oil production(Sm3)': production_profile})
                
                   production_profile1 = np.zeros(20)
                   with open(rsm_file, 'r') as f:
                       
                       lines = f.readlines()
                       for d in range(0, 20):
                           # Extract cumulative water production data
                           keyword1 = 'FWPT'
                           kw_line1 = next((index for (index, line) in enumerate(lines) if keyword1 in line), None)
                           #kw_line1 = next((index for (index, line) in enumerate(lines) if keyword1 in line), None)
                           print(f'kw_line1: {kw_line1}')
                           wanted_line1 = 2 + int(0) + kw_line1
                           particular_line1 = lines[wanted_line1]
                           x1 = particular_line1.split()
                           search_string = '*10**3'

                           if any(search_string in element for element in x1):
                               wanted_line2 = 7 + d + kw_line1
                               particular_line2 = lines[wanted_line2]
                               x2 = particular_line2.split()   
                               #print (x)
                               production_profile1[d] = float(x2[6]) * 10**3
                           else:
                               wanted_line2 = 6 + d + kw_line1
                               particular_line2 = lines[wanted_line2]
                               x2 = particular_line2.split()   
                               #print (x)
                               production_profile1[d] = float(x2[6])
                      

                   # Create a DataFrame to hold the production profile data
                   
                   df_water = pd.DataFrame(data={'Year': range(1, 21), 'cumulative water production(Sm3)': production_profile1})
                   
                   
                   production_profile2 = np.zeros(20)
                   with open(rsm_file, 'r') as f:
                       lines = f.readlines()
                       for d in range(0, 20):
                           # Extract cumulative gas production data
                           keyword1 = 'FGPT'
                           kw_line1 = next((index for (index, line) in enumerate(lines) if keyword1 in line), None)
                           #kw_line1 = next((index for (index, line) in enumerate(lines) if keyword1 in line), None)
                           print(f'kw_line1: {kw_line1}')
                           wanted_line1 = 2 + int(0) + kw_line1
                           particular_line1 = lines[wanted_line1]
                           x1 = particular_line1.split()
                           search_string = '*10**3'

                           if any(search_string in element for element in x1):
                               wanted_line2 = 7 + d + kw_line1
                               particular_line2 = lines[wanted_line2]
                               x2 = particular_line2.split()   
                               #print (x)
                               production_profile1[d] = float(x2[6]) * 10**3
                           else:
                               wanted_line2 = 6 + d + kw_line1
                               particular_line2 = lines[wanted_line2]
                               x2 = particular_line2.split()   
                               #print (x)
                               production_profile1[d] = float(x2[6])
                               
                    # Create a DataFrame to hold the production profile data
                    
                   df_gas = pd.DataFrame(data={'Year': range(1, 21), 'cumulative gas production(Sm3)': production_profile2})            
                   
                  
                   Proprof = f'E:/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS_{i}/production_profiles_{i}_{j}.xlsx'
        
                  # Save production profiles to an Excel file
                   with pd.ExcelWriter (f'E:/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS_{i}/production_profiles_{i}_{j}.xlsx') as writer:
                       df_water.to_excel(writer, sheet_name='Water', index=False) 
                       df_oil.to_excel(writer, sheet_name='Oil', index=False)  
                       df_gas.to_excel(writer, sheet_name='Gas', index=False)
                   
                   # Read the Excel file and perform calculations
                   df = pd.read_excel(Proprof, sheet_name='Oil')

                   # Calculate the yearly oil production
                   yearly_oil_production = df['cumulative oil production(Sm3)'] - df['cumulative oil production(Sm3)'].shift(fill_value=0)

                   # Add the new column to the DataFrame
                   df['yearly oil production(Sm3)'] = yearly_oil_production
                    
                   
                   # Write the DataFrame with the new column to the same Excel file and sheet
                   with pd.ExcelWriter(Proprof, engine='openpyxl', mode='a', if_sheet_exists='replace') as writer:
                        df.to_excel(writer, sheet_name='Oil', index=False)
                       
                   # Repeat the same steps for water and gas    
                   df = pd.read_excel(Proprof, sheet_name='Water')

                    
                   yearly_water_production = df['cumulative water production(Sm3)'] - df['cumulative water production(Sm3)'].shift(fill_value=0)

                     
                   df['yearly water production(Sm3)'] = yearly_water_production
                     
                   
                         
                   with pd.ExcelWriter(Proprof, engine='openpyxl', mode='a', if_sheet_exists='replace') as writer:
                        df.to_excel(writer, sheet_name='Water', index=False) 
                        
                   df = pd.read_excel(Proprof, sheet_name='Gas')

                    
                   yearly_gas_production = df['cumulative gas production(Sm3)'] - df['cumulative gas production(Sm3)'].shift(fill_value=0)

                     
                   df['yearly gas production(Sm3)'] = yearly_gas_production
                     # Write the DataFrame to an Excel file and save it
                   
                         
                   with pd.ExcelWriter(Proprof, engine='openpyxl', mode='a', if_sheet_exists='replace') as writer:
                        df.to_excel(writer, sheet_name='Gas', index=False)      
           
                    
           results = {}

           
           for l in input_list:
               for s in range(1, jrange+1):
                   proprof2 =f'E:/OLYMPUS_{l}/OLYMPUS_{l}_{s}/OLYMPUS_{l}/production_profiles_{l}_{s}.xlsx'
        
                   if not os.path.exists(proprof2):
                       # RSM file doesn't exist, so pass and go to the next one
                    continue
                   
                  

                   # Read the Excel file and extract the 'oil' sheet
                   df = pd.read_excel(proprof2, sheet_name='Oil')

                   # Calculate the sum of the values in the 'oil production' column
                   total_oil = df['yearly oil production(Sm3)'].sum()

                   # Store the result in the dictionary
                   name = 'OLYMPUS'+f'_{l}_{s}'
                   results[name] = 100*(total_oil/49000000)

                   # Create a new DataFrame from the results dictionary
                   new_df = pd.DataFrame.from_dict(results, orient='index', columns=['Recovery factor'])

                   # Add a 'name' column
                   new_df['name'] = new_df.index.str.replace('OLYMPUS_', 'OLYMPUS_', regex=True).str.replace('.xlsx', '', regex=False)


                   # Write the new DataFrame to a new Excel file
                   output_file_name = 'E:/OLYMPUS_Recovery.xlsx'
                   new_df.to_excel(output_file_name, index=False, header=True)
                   
                   # Read the data from the Excel file
                   input_file_name = 'E:/OLYMPUS_Recovery.xlsx'
                   df = pd.read_excel(input_file_name)

                   # Group the dataframe by the first part of the name (i.e. OLYMPUS_{i})
                   groups = df.groupby(df['name'].str.split('_', expand=True)[1])

                   # Write each group to a separate sheet in a new Excel file
                   output_file_name = 'E:/Recovery_separated.xlsx'
                   with pd.ExcelWriter(output_file_name) as writer:
                       for name, group in groups:
                           sheet_name = f'OLYMPUS_{name}'
                           group.to_excel(writer, sheet_name=sheet_name, index=False)

           
           
                   
           # Create an empty list to store the dataframes for oil, water and gas production
           oil_df_list = []
           water_df_list = []   
           gas_df_list = []
           
           for i in input_list:
                for j in range (1, jrange+1):
                   proprof3 =f'E:/OLYMPUS_{i}/OLYMPUS_{i}_{j}/OLYMPUS_{i}/production_profiles_{i}_{j}.xlsx'
         
                   if not os.path.exists(proprof3):
                        # RSM file doesn't exist, so pass and go to the next one
                     continue
                 

                    # Read the oil, water and gas production data from the Excel file
                   oil_df = pd.read_excel(proprof3, sheet_name='Oil')
                   oil_column_name = f'Oil_production_{i}_{j}'
                   oil_df = oil_df.iloc[:, 2].rename(oil_column_name)
                   oil_df_list.append(oil_df)

                   water_df = pd.read_excel(proprof3, sheet_name='Water')
                   water_column_name = f'Water_production_{i}_{j}'
                   water_df = water_df.iloc[:, 2].rename(water_column_name)
                   water_df_list.append(water_df)
                   
                   gas_df = pd.read_excel(proprof3, sheet_name='Gas')
                   gas_column_name = f'Gas_production_{i}_{j}'
                   gas_df = gas_df.iloc[:, 2].rename(gas_column_name)
                   gas_df_list.append(gas_df)
                   
                  
                # Concatenate all oil, water and gas dataframes into a single dataframe
                oil_df_final = pd.concat(oil_df_list, axis=1)

                water_df_final = pd.concat(water_df_list, axis=1)
                
                gas_df_final = pd.concat(gas_df_list, axis=1)

                # Write the oil, water and gas dataframes to a new Excel file
                output_file = f'E:/production_summary_OLYMPUS{i}.xlsx'
                
               
                with pd.ExcelWriter(output_file) as writer:
                    oil_df_final.index += 1
                    water_df_final.index += 1
                    gas_df_final.index += 1
                    
                    # Write to Excel file
                    oil_df_final.to_excel(writer, sheet_name='Oil_production', index=True)
                    water_df_final.to_excel(writer, sheet_name='Water_production', index=True)
                    gas_df_final.to_excel(writer, sheet_name='Gas_production', index=True)
            
   
            
              

          

    def run(self):
        
        # The `run` method is a part of a class and is used to start the main event loop of the GUI application.
        # It runs indefinitely until the GUI window is closed by the user.
        self.root.mainloop()
            

if __name__ == '__main__':
    gui = MyGUI()
    gui.run()
    # This is the entry point of the script when it is run as a standalone program.
    # It creates an instance of the `MyGUI` class and calls its `run` method to start the GUI application.
    # The `if __name__ == '__main__':` condition ensures that this block of code is only executed when the script is run directly,
    # and not when it is imported as a module.